interface Circle {
    radius: number;//property
    (x: number, y: number): void; //function declaration
    display(b: boolean);//method
    [state: string]: any; //indexer
}

//first create function
let c = function (x: number, y: number) {
    console.log(`center position: (${x}, ${y})`);
}

let circle: Circle = c as Circle; //type assertion on right side
circle.radius = 10;
circle.display = function (d: boolean) {
    console.log('circle displayed: ' + d);
}
circle['interactive'] = true;
circle['maximumRadius'] = 20;

console.log(circle);
circle(2, 5);// calling position function
circle.display(true);